﻿local CLOCK_UPDATE_RATE = 0.1;
local TimeSinceLastUpdate = 0;

if (not SoW_ItemDictionary) then
	SoW_Clock = {};
	SoW_Clock.TipSet = 0;
	SoW_Clock.TipList = 30;
end

--호출 시작 명령어 모음 시작--
SLASH_Clock1 = "/ㄴㅊ";
SLASH_Clock2 = "/sc";
SLASH_Clock3 = "/ㅅㄱ";
--호출 시작 명령어 모음 종료--

function SoW_Clock_OnLoad()
	this:RegisterEvent( "PLAYER_ENTERING_WORLD" );
	this:RegisterForDrag("LeftButton", "RightButton");
end

-- 호출 명령어로 실행 가능한 기능 시작 --
SlashCmdList.Clock = function(msg)	
	msg = strtrim(msg);
	cmd = gsub(msg, "(.*)@(.*)", "%1");
	argument = gsub(msg, "(.*)@(.*)", "%2");

	if cmd == "sc" or cmd == "scale" or cmd == "크기" or cmd == "ㅋㄱ" then
		SoW_ClockFrame:SetHeight(40*argument)
		SoW_ClockFrame:SetWidth(160*argument)
		
		SoW_ClockText1:SetHeight(30*argument)
		SoW_ClockText1:SetWidth(100*argument)
		SoW_ClockText1:SetPoint("Center", SoW_ClockFrame, "Center", -32*argument, 4*argument)
		SoW_ClockText1:SetTextHeight(24*argument)
		
		SoW_ClockText2:SetHeight(16*argument)
		SoW_ClockText2:SetWidth(35*argument)
		SoW_ClockText2:SetPoint("Center", SoW_ClockFrame, "Center", 34*argument, -1*argument)
		SoW_ClockText2:SetTextHeight(12*argument)
		
		SoW_ClockDate3:SetHeight(12*argument)
		SoW_ClockDate3:SetWidth(30*argument)
		SoW_ClockDate3:SetPoint("Center", SoW_ClockFrame, "Center", 64*argument, -1*argument)
		SoW_ClockDate3:SetTextHeight(12*argument)
		
		SoW_ClockInfo:SetHeight(12*argument)
		SoW_ClockInfo:SetWidth(160*argument)
		SoW_ClockInfo:SetPoint("Center", SoW_ClockFrame, "Center", 1*argument, -14*argument)
		SoW_ClockInfo:SetTextHeight(11*argument)
		
		SoW_ClockDate:SetHeight(12*argument)
		SoW_ClockDate:SetWidth(65*argument)
		SoW_ClockDate:SetPoint("Center", SoW_ClockFrame, "Center", 48*argument, 9*argument)
		SoW_ClockDate:SetTextHeight(11*argument)
		
	elseif cmd == "tl" or cmd == "tiplist" or cmd == "ㅁㄹ" or cmd == "목록" then
	  SoW_Clock.TipList = argument*1;
		
	elseif cmd == "?" then
		DEFAULT_CHAT_FRAME:AddMessage("Not Yet...");
		return;
  end
end

function SoW_Clock_OnUpdate(arg1)
	TimeSinceLastUpdate = TimeSinceLastUpdate + arg1;

	if ( TimeSinceLastUpdate > CLOCK_UPDATE_RATE ) then
		local l_WeekName = {"|CFFFF4444일|r","월","화","수","목","금","|CFF4444BB토|r"};
		local l_DateText = string.format("%s%s%s",date("|cFFFFCC00%m|r"),"|cFFFFFFFF/|r",date("|cFFFFCC00%d|r"));
		SoW_ClockDate:SetText(l_DateText);

		local l_DateText1 = date("%I:%M");
		local l_DateText2 = date("%p");
		local I_DateText3 = l_WeekName[tonumber(date("%w", time()))+1];
		SoW_ClockDate3:SetText("|cFFFFFFFF[|r"..I_DateText3.."|cFFFFFFFF]|r");
		
		SoW_ClockDate:SetText(l_DateText);
		SoW_ClockText1:SetText(l_DateText1);
		SoW_ClockText2:SetText(l_DateText2);
		SoW_ClockText1:SetTextColor(0.0,0.6,1.0);
		SoW_ClockText2:SetTextColor(0.8,0.8,0.8);
		

		-- FPS & 메모리 & 네트웍지연율
		local l_mem_size = gcinfo() / 1024;
		local l_mem_color = "FFFFFF";
		if ( l_mem_size > 50 ) then
			l_mem_color = "FF0000";
		elseif ( l_mem_size > 40 ) then
			l_mem_color = "FF9900";
		elseif ( l_mem_size > 30 ) then
			l_mem_color = "FFFF00";
		elseif ( l_mem_size > 20 ) then
			l_mem_color = "BBFF00";
		elseif ( l_mem_size > 10 ) then
			l_mem_color = "66FF00";
		else
			l_mem_color = "00FF00";
		end

		local l_fps = GetFramerate();
		local l_fps_Color = "FFFFFF";
		if ( l_fps > 45 ) then
			l_fps_color = "00FF00";
		elseif ( l_fps > 30 ) then
			l_fps_color = "66FF00";
		elseif ( l_fps > 20 ) then
			l_fps_color = "BBFF00";
		elseif ( l_fps > 15 ) then
			l_fps_color = "FFFF00";
		elseif ( l_fps > 10 ) then
			l_fps_color = "FF9900";
		else
			l_fps_color = "FF0000";
		end

		local l_NetIn, l_NetOut, l_latency = GetNetStats();
		local l_latency_color = "FFFFFF";
		if ( l_latency > 300 ) then
			l_latency_color = "FF0000";
		elseif ( l_latency > 250 ) then
			l_latency_color = "FF9900";
		elseif ( l_latency > 200 ) then
			l_latency_color = "FFFF00";
		elseif ( l_latency > 100 ) then
			l_latency_color = "BBFF00";
		elseif ( l_latency > 50 ) then
			l_latency_color = "66FF00";
		else
			l_latency_color = "00FF00";
		end

		local l_InfoText = string.format("|cff%s%.0f|c00FFFFFFfps", l_fps_color, GetFramerate())..string.format("  |cff%s%.1f|c00FFFFFFMiB", l_mem_color, gcinfo() / 1024)..string.format("  |cff%s%.0f|r|c00FFFFFFms", l_latency_color, l_latency);
		SoW_ClockInfo:SetText(l_InfoText);

		TimeSinceLastUpdate = 0;
	end
end

function SoW_Clock_OnDragStart(arg1)
	if (IsAltKeyDown() and arg1 == "LeftButton") then
		SoW_ClockFrame:StartMoving();
		return;
	end
end

function SoW_Clock_OnDragStop()
	SoW_ClockFrame:StopMovingOrSizing();
end

function SoW_Clock_OnClick(arg1)
	if arg1 == "LeftButton" then
		local old = gcinfo();
		collectgarbage( 'collect' );
		local new	= gcinfo();
		local erased	= old - new;
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFFFF정리된 메모리|r : " .. MemTex(erased));
		return;
		
	elseif arg1 == "RightButton" then
--		if SoW_Clock.TipSet == 0 then
--			SoW_Clock.TipSet = 1
--		elseif SoW_Clock.TipSet == 1 then
--			SoW_Clock.TipSet = 0
--		end
    if not IsAddOnLoaded("Blizzard_Calendar") then
      LoadAddOn("Blizzard_Calendar")
		end
		Calendar_Toggle()
	end
end

function SoW_Clock_OnEnter()
 	TooltipShow(SoW_Clock.TipSet, SoW_Clock.TipList)
end

function MemTex(Num)
	local AddonMem
	if Num > 10240 then
		Num = Num/1024
		AddonMem = "|cFFFF0000" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 5120 then
		Num = Num/1024
		AddonMem = "|cFFFF4400" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 2048 then
		Num = Num/1024
		AddonMem = "|cFFFF8800" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 1024 then
		Num = Num/1024
		AddonMem = "|cFFFFAA00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 786 then
		AddonMem = "|cFFFFCC00" .. string.format("%.2f", Num).. " |cFFFFFFFFKiB"
	elseif Num > 512 then
		AddonMem = "|cFFFFFF00" .. string.format("%.2f", Num).. " |cFFFFFFFFKiB"
	elseif Num > 256 then
		AddonMem = "|cFF88FF00" .. string.format("%.2f", Num).. " |cFFFFFFFFKiB"
	else
		AddonMem = "|cFF00FF00" .. string.format("%.2f", Num).. " |cFFFFFFFFKiB"
	end

	return(AddonMem)
end

function MemPerTex(Num)
	local AddonMem
	if Num >= 50 then
		AddonMem = "|cFFFF0000" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 40 then
		AddonMem = "|cFFFF4400" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 30 then
		AddonMem = "|cFFFF8800" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 20 then
		AddonMem = "|cFFFFAA00" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 10 then
		AddonMem = "|cFFFFCC00" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	elseif Num > 5 then
		AddonMem = "|cFFFFFF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	elseif Num > 2.5 then
		AddonMem = "|cFF88FF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	else
		AddonMem = "|cFF00FF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	end

	return(AddonMem)
end

function TooltipShow(ToolTipSet, ToolTipList)
  if ToolTipSet == 0 then
    GameTooltip:SetOwner(SoW_ClockFrame, "ANCHOR_BOTTOMLEFT", 0, 0);

    local memory, i, addons, total, entry, total;
    
    GameTooltip:AddLine("|cFFFFCC00Alt+좌클릭: |c00FFFFFF이동");
    GameTooltip:AddLine("|cFFFFCC00좌클릭: |c00FFFFFF메모리 정리");
    GameTooltip:AddLine("|cFFFFCC00우클릭: |c00FFFFFF달력 열기");

    GameTooltip:AddLine("|cFFFFFFFF===============================================|r")

    GameTooltip:AddLine("상위 " .. ToolTipList .. "개 애드온", 0, 0.6, 1)

    GameTooltip:AddLine("|cFFFFFFFF===============================================|r")

    addons = {}
   	local number = 0
  	total = 0
    UpdateAddOnMemoryUsage()
    for i = 1, GetNumAddOns(), 1 do
      if GetAddOnMemoryUsage(i) > 0 then
        memory = GetAddOnMemoryUsage(i)
        entry = {name = GetAddOnInfo(i), memory = memory}
        table.insert(addons, entry)
        total = total + memory
      end
    end

    table.sort(addons, function(a, b) return a.memory > b.memory end)

    for _,entry in pairs(addons) do
  		if number < ToolTipList then
  			if number < 9 then
  				GameTooltip:AddDoubleLine("|cFFFFFFFF  " .. number + 1 .. ". |cFFFFCC00"..entry.name, MemTex(entry.memory) .. " |cFFFFCC00/|r |cFFFFCC00" .. MemPerTex(entry.memory/total*100))
  			else
  				GameTooltip:AddDoubleLine("|cFFFFFFFF" .. number + 1 .. ". |cFFFFCC00"..entry.name, MemTex(entry.memory) .. " |cFFFFCC00/|r |cFFFFCC00" .. MemPerTex(entry.memory/total*100))
  			end
  			number = number + 1
  		end
  	end
  	GameTooltip:AddLine("|cFFFFFFFF===============================================|r")
  	
    GameTooltip:AddDoubleLine("사용자 애드온 합계", MemTex(total))
    GameTooltip:AddDoubleLine("블리자드 기본 UI 합계", MemTex(collectgarbage("count") - total))
    GameTooltip:AddDoubleLine("총 합계", MemTex(collectgarbage("count")))

  	GameTooltip:Show();
  	
  --elseif ToolTipSet == 1 then
  	
	end
end

function SoW_Clock_OnLeave()
	GameTooltip:Hide();
end